//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uFuncs.h"
#include "uSolver.h"
//#include <math.h>
#include <fstream.h>

#include "uMain.h"
#include "uAbout.h"
#include "uAddEditComp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::miExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::miAboutClick(TObject *Sender)
{
  fmAbout = new TfmAbout(this);
  fmAbout->imgMain->Picture->Icon=Application->Icon;
  fmAbout->ShowModal();
  delete fmAbout;
}
//---------------------------------------------------------------------------



void __fastcall TfmMain::actAddCompExecute(TObject *Sender)
{
  fmAddEditComp = new TfmAddEditComp(this);
  fmAddEditComp->ShowModal();
  if (fmAddEditComp->ModalResult==mrOk)
  {
    int Cost=StrToInt(ProcessMaskEditString(fmAddEditComp->meCost->Text));
    int Weight=StrToInt(ProcessMaskEditString(fmAddEditComp->meWeight->Text));
    float P=StrToFloat(ProcessMaskEditString(fmAddEditComp->meFaultTolerance->Text));
    int Index = 0;
    if (lvComponentsList->Selected!=NULL)
    {
      Index=lvComponentsList->Selected->Index;
      if (fmAddEditComp->cbAddAfter->Checked)
        Index++;
    }
    TListItem *InsertItem = lvComponentsList->Items->Insert(Index);
    InsertItem->Caption=IntToStr(Index+1);
    InsertItem->SubItems->Add(IntToStr(Cost));
    InsertItem->SubItems->Add(IntToStr(Weight));
    InsertItem->SubItems->Add(FloatToStrF(P, ffFixed, 1, 2));

    for (int i=Index+1; i<=lvComponentsList->Items->Count-1; i++)
      lvComponentsList->Items->Item[i]->Caption=IntToStr(i+1);
  }
  delete fmAddEditComp;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actEditCompExecute(TObject *Sender)
{
  if (lvComponentsList->Selected!=NULL)
  {
    fmAddEditComp = new TfmAddEditComp(this);
    fmAddEditComp->Caption=" ";
    fmAddEditComp->meCost->Text=lvComponentsList->Selected->SubItems->Strings[0];
    fmAddEditComp->meWeight->Text=lvComponentsList->Selected->SubItems->Strings[1];
    fmAddEditComp->meFaultTolerance->Text=lvComponentsList->Selected->SubItems->Strings[2];
    fmAddEditComp->cbAddAfter->Visible=false;
    fmAddEditComp->ShowModal();
    if (fmAddEditComp->ModalResult==mrOk)
    {
      int Cost=StrToInt(ProcessMaskEditString(fmAddEditComp->meCost->Text));
      int Weight=StrToInt(ProcessMaskEditString(fmAddEditComp->meWeight->Text));
      float P=StrToFloat(ProcessMaskEditString(fmAddEditComp->meFaultTolerance->Text));

      lvComponentsList->Selected->SubItems->Strings[0]=IntToStr(Cost);
      lvComponentsList->Selected->SubItems->Strings[1]=IntToStr(Weight);
      lvComponentsList->Selected->SubItems->Strings[2]=FloatToStrF(P, ffFixed, 1, 2);
    }
    delete fmAddEditComp;
  }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actDeleteCompExecute(TObject *Sender)
{
  if (lvComponentsList->Selected!=NULL)
  {
    int Index=lvComponentsList->Selected->Index;
    lvComponentsList->Selected->Delete();
    for (int i=Index; i<=lvComponentsList->Items->Count-1; i++)
      lvComponentsList->Items->Item[i]->Caption=IntToStr(i+1);
  }
}
//---------------------------------------------------------------------------


void __fastcall TfmMain::lvComponentsListSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
  actEditComp->Enabled=lvComponentsList->Selected!=NULL;
  actDeleteComp->Enabled=lvComponentsList->Selected!=NULL;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actFindSolutionExecute(TObject *Sender)
{
  N = lvComponentsList->Items->Count;

  if (!N)
  {
    MessageBox(0, "      .", "", MB_ICONEXCLAMATION | MB_TASKMODAL | MB_OK);
    return;
  }

  C = new int [N];
  G = new int [N];
  Q = new float [N];

  for (int i=0; i<=(N-1); i++)
  {
    C[i]=StrToInt(lvComponentsList->Items->Item[i]->SubItems->Strings[0]);
    G[i]=StrToInt(lvComponentsList->Items->Item[i]->SubItems->Strings[1]);
    Q[i]=StrToFloat(lvComponentsList->Items->Item[i]->SubItems->Strings[2]);
  }

  int MaxC = StrToInt(ProcessMaskEditString(meMaxCost->Text));
  int MaxG = StrToInt(ProcessMaskEditString(meMaxWeight->Text));
  int CombsN = (MaxC + 1) * ( MaxG + 1);

  Tables = new EntryStruct* [N];
  for (int i=0; i<=(N-1); i++)
    Tables[i] = new EntryStruct [CombsN];

  float Z = Solve(MaxC, MaxG);

  int X = Tables[0][MaxC*(MaxG+1)+MaxG].XValue;
  AnsiString S = "    : ("+IntToStr(X);

  int E1 = MaxC;
  int E2 = MaxG;

  for (int i=1; i<=(N-1); i++)
  {
    E1-=C[i-1]*X;
    E2-=G[i-1]*X;

    X = Tables[i][E1*(MaxG+1)+E2].XValue;

    S+=", "+IntToStr(X);
  }

  memOutput->Clear();
  memOutput->Lines->Add("    : "+FloatToStrF(Z, ffFixed, 1, 2));

  S+=")";
  memOutput->Lines->Add(S);

  for (int i=0; i<=(N-1); i++)
    delete[] Tables[i];
  delete[] Tables;

  delete[] C;
  delete[] G;
  delete[] Q;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::ResetControls()
{
  lvComponentsList->Items->Clear();

  meMaxCost->Text="";
  meMaxWeight->Text="";

  memOutput->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actCreateExecute(TObject *Sender)
{
  sdMain->FileName="";
  ResetControls();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actOpenExecute(TObject *Sender)
{
  if (odMain->Execute())
  {
    sdMain->FileName=odMain->FileName;
    ResetControls();

    ifstream InF(odMain->FileName.c_str());

    int ti;

    InF >> ti;
    meMaxCost->Text=IntToStr(ti);
    InF >> ti;
    meMaxWeight->Text=IntToStr(ti);

    InF >> ti;
    float tf;
    int ti2;

    for (int i=1; i<=ti; i++)
    {
      TListItem *NewItem = lvComponentsList->Items->Add();
      NewItem->Caption=IntToStr(i);

      InF >> ti2;
      NewItem->SubItems->Add(IntToStr(ti2));
      InF >> ti2;
      NewItem->SubItems->Add(IntToStr(ti2));
      InF >> tf;
      NewItem->SubItems->Add(FloatToStrF(tf, ffFixed, 1, 2));
    }

    InF.close();
  }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::DoSaveProject()
{
  ofstream OutF(sdMain->FileName.c_str());

  int ti, ti2;
  float tf;

  ti = StrToInt(ProcessMaskEditString(meMaxCost->Text));
  ti2 = StrToInt(ProcessMaskEditString(meMaxWeight->Text));

  OutF << ti << ' ' << ti2 << '\n';

  OutF << lvComponentsList->Items->Count << '\n';

  for (int i=0; i<=lvComponentsList->Items->Count-1; i++)
  {
    ti=StrToInt(lvComponentsList->Items->Item[i]->SubItems->Strings[0]);
    ti2=StrToInt(lvComponentsList->Items->Item[i]->SubItems->Strings[1]);
    tf=StrToFloat(lvComponentsList->Items->Item[i]->SubItems->Strings[2]);
    OutF << ti << ' ' << ti2 << ' ' << tf << '\n';
  }

  OutF.close();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::actSaveExecute(TObject *Sender)
{
  if (sdMain->FileName!="")
    DoSaveProject();
  else
    if (sdMain->Execute())
      DoSaveProject();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormCreate(TObject *Sender)
{
  Application->HelpFile=ChangeFileExt(Application->ExeName, ".hlp");

  DecimalSeparator='.';
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::miTaskClick(TObject *Sender)
{
  Application->HelpJump("Task");
}
//---------------------------------------------------------------------------

