//---------------------------------------------------------------------------


#pragma hdrstop

#include "uSolver.h"
#include <math.h>
#include <mem.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)

int N;
int* C;
int* G;
float* Q;
EntryStruct** Tables;

int min(int value1, int value2)
{
  return ((value1 < value2) ? value1 : value2);
}

float Solve(int E1, int E2)
{
  int c, g;
  float q;
  int i, j, x;
  float W;
  EntryStruct Entry;
  for (int k=(N-1); k>0; k--)
  {
    c=C[k];
    g=G[k];
    q=Q[k];

    for (i=0; i<=E1; i++)
      for (j=0; j<=E2; j++)
      {
        Entry.XValue=0;
        Entry.W=0;
        for (x=1; x<=min(i/c, j/g); x++)
        {
          W=1-pow((1-q), x);
          if (k!=(N-1))
            W*=Tables[k+1][(i-c*x)*(E2+1)+(j-g*x)].W;
          if (W > Entry.W)
          {
            Entry.XValue=x;
            Entry.W=W;
          }
        }
        Tables[k][i*(E2+1)+j]=Entry;
      }
  }


  c=C[0];
  g=G[0];
  q=Q[0];

  Entry.XValue=0;
  Entry.W=0;
  for (x=1; x<=min(E1/c, E2/g); x++)
  {
    W=1-pow((1-q), x);
    if (N > 1)
      W*=Tables[1][(E1-c*x)*(E2+1)+(E2-g*x)].W;
    if (W > Entry.W)
    {
      Entry.XValue=x;
      Entry.W=W;
    }
  }
  Tables[0][E1*(E2+1)+E2]=Entry;


  return Entry.W;
}